/***
*
*	Copyright (c) 1996-2001, Valve LLC. All rights reserved.
*	
*	This product contains software technology licensed from Id 
*	Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc. 
*	All Rights Reserved.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/
//
// battery.cpp
//
// implementation of CHudBattery class
//

#include "hud.h"
#include "cl_util.h"
#include "parsemsg.h"

#include <string.h>
#include <stdio.h>

DECLARE_MESSAGE(m_Battery, Battery)

int CHudBattery::Init(void)
{
	m_iBat = 0;
        m_fFade = 0;
	m_iFlags = 0;

	HOOK_MESSAGE(Battery);

	gHUD.AddHudElem(this);

	return 1;
};


int CHudBattery::VidInit(void)
{
	int HUD_suit_empty = gHUD.GetSpriteIndex( "suit_empty" );
	int HUD_suit_full = gHUD.GetSpriteIndex( "suit_full" );

	m_hSprite1 = m_hSprite2 = 0;  // delaying get sprite handles until we know the sprites are loaded
	m_prc1 = &gHUD.GetSpriteRect( HUD_suit_empty );
	m_prc2 = &gHUD.GetSpriteRect( HUD_suit_full );
	m_iHeight = m_prc2->bottom - m_prc1->top;




	return 1;
};

int CHudBattery:: MsgFunc_Battery(const char *pszName,  int iSize, void *pbuf )
{
        
        m_iFlags |= HUD_ACTIVE;//...uh dont delete this line

	
	BEGIN_READ( pbuf, iSize );
	int x = READ_SHORT();

        //update only on change.
        //bc
        //if (x != m_iBat)
	{
                //bc this gets updated regardless.
                m_fFade = 1.0;
                //m_iBat = x;
                thetime = x;
                PlaySound("ding.wav", 1);
	}

	return 1;
}


int CHudBattery::Draw(float flTime)
{
//bc
        //draws a number once per second.
        m_fFade -= gHUD.m_flTimeDelta;
        if (m_fFade < 0.0)
        {
                m_fFade = 1.0;
                if (thetime > 0)
                {
                        thetime--;

                        //the bloop sound fx
                        if (thetime < 6)
                        {
                                switch (thetime)
                                {
                                        case 5:PlaySound("boo5.wav", 1);break;
                                        case 4:PlaySound("boo4.wav", 1);break;
                                        case 3:PlaySound("boo3.wav", 1);break;
                                        case 2:PlaySound("boo2.wav", 1);break;
                                        case 1:PlaySound("boo1.wav", 1);break;
                                        case 0:PlaySound("boo0.wav", 1);break;
                                }
                        }
                }

        }

        if (m_fFade <= 1.0)
        {
                //center the digits in the little box.
                //handles up to three digits! assume no one uses 4 digits.
                int xoffset; //the x coord of timer numbers.
                if (thetime >= 100)
                        xoffset = ScreenWidth - 29;
                else if (thetime >= 10)
                        xoffset = ScreenWidth - 24;
                else
                        xoffset = ScreenWidth - 20;

                //draw the digits.
                char szHeal[4];
                sprintf(szHeal,"%i",thetime);
                gEngfuncs.pfnDrawSetTextColor( 1, 1, 1 );
                DrawConsoleString(xoffset,(ScreenHeight / 2) + 2,szHeal);
        }



        return 1;


/*
	if ( gHUD.m_iHideHUDDisplay & HIDEHUD_HEALTH )
		return 1;

	int r, g, b, x, y, a;
	wrect_t rc;

	rc = *m_prc2;
	rc.top  += m_iHeight * ((float)(100-(min(100,m_iBat))) * 0.01);	// battery can go from 0 to 100 so * 0.01 goes from 0 to 1

	UnpackRGB(r,g,b, RGB_YELLOWISH);

	if (!(gHUD.m_iWeaponBits & (1<<(WEAPON_SUIT)) ))
		return 1;

	// Has health changed? Flash the health #
	if (m_fFade)
	{
		if (m_fFade > FADE_TIME)
			m_fFade = FADE_TIME;

		m_fFade -= (gHUD.m_flTimeDelta * 20);
		if (m_fFade <= 0)
		{
			a = 128;
			m_fFade = 0;
		}

		// Fade the health number back to dim

		a = MIN_ALPHA +  (m_fFade/FADE_TIME) * 128;

	}
	else
		a = MIN_ALPHA;

	ScaleColors(r, g, b, a );
	
	int iOffset = (m_prc1->bottom - m_prc1->top)/6;

	y = ScreenHeight - gHUD.m_iFontHeight - gHUD.m_iFontHeight / 2;
	x = ScreenWidth/5;

	// make sure we have the right sprite handles
	if ( !m_hSprite1 )
		m_hSprite1 = gHUD.GetSprite( gHUD.GetSpriteIndex( "suit_empty" ) );
	if ( !m_hSprite2 )
		m_hSprite2 = gHUD.GetSprite( gHUD.GetSpriteIndex( "suit_full" ) );

	SPR_Set(m_hSprite1, r, g, b );
	SPR_DrawAdditive( 0,  x, y - iOffset, m_prc1);

	if (rc.bottom > rc.top)
	{
		SPR_Set(m_hSprite2, r, g, b );
		SPR_DrawAdditive( 0, x, y - iOffset + (rc.top - m_prc2->top), &rc);
	}

	x += (m_prc1->right - m_prc1->left);
	x = gHUD.DrawHudNumber(x, y, DHN_3DIGITS | DHN_DRAWZERO, m_iBat, r, g, b);

	return 1;
*/
}
